<template>
  <section>
    <Header/>
    <transition name="fade">
      <form v-if="check === 0" class="reg" @submit.prevent="registration">
        <h2>Регистрация</h2>
        <input v-model="register.name" type="text" placeholder="Введите логин" required>
        <input v-model="register.email" type="email" placeholder="Введите почту" required>
        <input v-model="register.password" type="password" placeholder="Введите пароль" required>
        <input v-model="register.c_password" type="password" placeholder="Повторите пароль" required>
        <button type="submit">Зарегистрироваться</button>
      </form>

      <form v-if="check === 1" class="auth" @submit.prevent="authorization">
        <h2>Авторизация</h2>
        <input type="text" placeholder="Логин" v-model="login.name">
        <input type="password" placeholder="Пароль" v-model="login.password">
        <button type="submit">Войти</button>
      </form>
    </transition>
    <div class="buttons">
      <span @click="check = 0" :class="{'active': check === 0}">Регистрация</span>
      <span @click="check = 1" :class="{'active' : check === 1}">Авторизавция</span>
    </div>
  </section>
</template>

<script>
import Header from "@/components/Header";
export default {
  name: "Login",
  components: {Header},
  data(){
    return{
      check: 0,
      register: {
        name: '',
        email: '',
        password: '',
        c_password: ''
      },
      login: {
        name: '',
        password: ''
      }
    }
  },

  methods:{
    async registration(){
      try {
        let body = new URLSearchParams();
        body.append("email", `${this.register.email}`);
        body.append("name", `${this.register.name}`);
        body.append("password", `${this.register.password}`);
        body.append("c_password", `${this.register.c_password}`);

        let myHeaders = new Headers();
        myHeaders.append("Accept", "application/json");
        myHeaders.append("Content-Type", "application/x-www-form-urlencoded");

        let req = await this.$api(this.$store.state.api_route.baseUrl + this.$store.state.api_route.register, 'POST', body, myHeaders)

        if (req.token){
          sessionStorage.setItem('token', req.token)
          this.$noty.success("Регистрация прошла успешно!")
          await this.$router.push('/')
        }

        else {
          console.log(req);
          this.$noty.error("Ошибка регистрации!")
        }
      }

      catch (e) {
        console.log(e);
        this.$noty.error("Ошибка регистрации!")
      }
    },

    async authorization(){
      try {
        let body = new URLSearchParams();
        body.append("name", `${this.login.name}`);
        body.append("password", `${this.login.password}`);

        let myHeaders = new Headers();
        myHeaders.append("Accept", "application/json");
        myHeaders.append("Content-Type", "application/x-www-form-urlencoded");

        let req = await this.$api(this.$store.state.api_route.baseUrl + this.$store.state.api_route.login, 'POST', body, myHeaders)

        if (req.access_token){
          sessionStorage.setItem('token', req.access_token)
          await this.$router.push('/')
        }

        else {
          console.log(req);
          this.$noty.error("Ошибка авторизации!")
        }
      }

      catch (e) {
        console.log(e);
        this.$noty.error("Ошибка авторизации!")
      }
    }
  }
}
</script>

<style scoped lang="scss">

section{
  width: 100%;
  height: 100%;
  display: flex;
  align-items: center;
  justify-content: center;
  flex-direction: column;

  .buttons{
    display: flex;
    align-items: center;

    span{
      margin-right: 2rem;
      font-size: 1rem;
      cursor: pointer;

      &:last-child{
        margin-right: 0;
      }
    }

    .active{
      color: green;
      position: relative;
      font-weight: bold;

      &::before{
        content: '';
        position: absolute;
        left: 0;
        top: 100%;
        width: 100%;
        height: 2px;
        background: green;
      }
    }
  }

  form.reg{
    margin: 0 auto;
    width: 30%;
    height: 60%;
    display: flex;
    flex-direction: column;
    align-items: center;
    align-self: flex-start;
    //box-shadow: 0 0 10px #ccc;
    border-radius: 8px;
    padding: 1rem;

    h2{
      text-align: center;
      font-size: 2.5rem;
      margin-bottom: 3rem;
    }

    input{
      width: 70%;
      margin-bottom: 1rem;
      padding: .7rem 1rem;
      border: none;
      border-bottom: 1px solid #000;
      transition: .2s;
      font-size: .94rem;

      &:focus{
        box-shadow: 0 0 5px #000000;
      }
    }

    button{
      margin-top: 1rem;
      font-size: 1rem;
      background: transparent;
      border: 1px solid #000;
      cursor: pointer;
      padding: .7rem 1rem;
      transition: .2s;

      &:hover{
        color: #fff;
        background: green;
        border-color: green;
      }
    }
  }

  form.auth{
    margin: 0 auto;
    width: 30%;
    height: 60%;
    display: flex;
    flex-direction: column;
    align-items: center;
    align-self: flex-start;
    border-radius: 8px;
    padding: 1rem;

    h2{
      text-align: center;
      font-size: 2.5rem;
      margin-bottom: 3rem;
    }

    input{
      width: 70%;
      margin-bottom: 3rem;
      padding: .7rem 1rem;
      border: none;
      border-bottom: 1px solid #000;
      transition: .2s;
      font-size: .94rem;

      &:focus{
        box-shadow: 0 0 5px #000000;
      }
    }

    button{
      margin-top: 1rem;
      font-size: 1rem;
      background: transparent;
      border: 1px solid #000;
      cursor: pointer;
      padding: .7rem 1rem;
      transition: .2s;

      &:hover{
        color: #fff;
        background: green;
        border-color: green;
      }
    }
  }
}

</style>